{
  
  "general": {
    "model": "MA-E3xx",
    "device_id": "",
    "feature_set": [ "svs","hips","wrs","aal" ],
    "collect_info": true,
    "base": "/",
    "pid_dir": "/var/run",
    "tmp_dir": "/tmp/.atom",
    "log": {
      "type": 1,
      "level": 48,
      "file": {
        "path": "/var/opt/atom/log",
        "rotate_size": 1048576,
        "rotate_count": 3
      }
      ,
      "ipc": {
        "max_ring_size": 16384,
        "max_chunk_size": 1024
      }
    }
    ,
    "security_events": {
      "syslog": {
        "enable": false,
        "facility": "user",
        "priority": "notice"
      }
    }
  }
  ,
  "d": {
    "pid_name": "atomd",
    "event": {
      "upload": {
        "thld_time_sec": 300,
        "rotate_count": 10
      }
    }
    ,
    "client": {
      "uids": [ 0 ],
      "paths": [ "/opt/atom/bin/atom" ]
    }
  }
  ,
  "wd": {
    "pid_name": "atomwd",
    "jobs": [
      
      {
        "svc_id": "hips",
        "pid_name": "heliumd",
        "name": "heliumd",
        "args": [":__auto_atom_conf__:"],
        "envs": ["HE_NOHOOK_=1"]
      }
      ,
      {
        "svc_id": "wrs",
        "pid_name": "heliumd",
        "name": "heliumd",
        "args": [":__auto_atom_conf__:"],
        "envs": ["HE_NOHOOK_=1"]
      }
      ,
      {
        "svc_id": "aal",
        "pid_name": "bariumd",
        "name": "bariumd",
        "args": [":__auto_atom_conf__:"]
      }
      ,
      {
        "svc_id": "aal",
        "pid_name": "lithiumd",
        "name": "lithiumd",
        "args": [":__auto_atom_conf__:"]
      }
    ]
  }
  ,
  "svc": {
    
    "svs": {
      "enable_dpkg_scan": true
    }
    ,
    "hips": {
      "hydhe": {
        "module_id": "he5"
      }
      ,
      "event": {
        "log": {
          "enable": false,
          "file_path": "/var/opt/atom/log/event_hips.log",
          "rotate_size": 16384,
          "rotate_count": 3
        }
      }
      ,
      "d": {
        "pid_name": "heliumd",
        "he": {
          "modules": "hips:he5/libhe5.so;wrs:he6/libhe6.so",
          "rule": {
            "default": "he5:pattern"
          },
          "event": {
            "timeout_s": 15,
            "win_size": 30
          }
        }
        ,
        "hed": {
          "shm_center_seg_size": 131071,
          "worker_num": 1,
          "libhhef": ""
        }
      }
    }
    ,
    "wrs": {
      "event": {
        "log": {
          "enable": false,
          "file_path": "/var/opt/atom/log/event_wrs.log",
          "rotate_size": 16384,
          "rotate_count": 3
        }
      }
    }
    ,
    "aal": {
      "baseline_root_dir": "/",
      "unnamed_mnt_pts": ["/", "/rw"],
      "maintainance_event_limit": 200000
      ,
      "event": {
        "log": {
          "enable": false,
          "file_path": "/var/opt/atom/log/event_aal.log",
          "rotate_size": 16384,
          "rotate_count": 3
        }
      }
      ,
      "d": {
        "pid_name": "lithiumd",
        "pid_name_sp": "bariumd",
        "kernel_rel": "${KVER}",
        "kernel_rel_date": "",
        "kernel_rel_check": "${KVER}",
        "hfmod": {
          "name": "hafnium.ko",
          "params": ["file_hcache_lru_max=1024", "log_level=6"]
        },
        "limod": {
          "name": "lithium.ko",
          "params": [
            "policy_lru_max=100",
            "log_level=6",
            "lilog_lru_max=150",
            "lilog_lru_ttu=60"
          ]
        },
        "bamod": {
          "name": "barium.ko",
          "params": [
            "log_level=6"
          ]
        }
      }
    }
  }
}
