# -*- coding: utf-8 -*-
import os
from Handlers import BaseHandler
from datetime import datetime
from Utils import MyTimer
# -------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------


class Datetime(BaseHandler.BaseHandler):
    # =======================================================
    #
    # =======================================================
    def __init__(self):
        self.config = "/etc/network/interfaces"
        self.name = 'Datetime'
    # =======================================================
    #
    # =======================================================

    def Get(self, request):
        status = 200
        data = {}
        data['datetime'] = self.getDatetime()
        data['timezone'] = self.getTimezone()
        return data, status

    # =======================================================
    #
    # =======================================================
    def Put(self, request):

        status = 200
        params = request.json
        if params["type"] == "timezone":
            # with open("/etc/timezone", "w") as file:
            #     timezone = file.write(params["timezone"])
            # self.call(
            #     "dpkg-reconfigure --frontend noninteractive tzdata",  shell=True)
            cmdline = "timedatectl set-timezone %s" % params["timezone"]
            self.call(cmdline, shell=True)

        elif params["type"] == "datetime":
            timer = MyTimer.MyTimer(
                1, self.setDatetime, args=[params["datetime"]])
            timer.start()
        return status

    # =======================================================
    #
    # =======================================================
    def getDatetime(self):

        now = datetime.now()
        date = {}
        date['year'] = now.year
        date['month'] = now.month
        date['day'] = now.day
        date['hour'] = now.hour
        date['minute'] = now.minute
        date['second'] = now.second

        return date

    # =======================================================
    #
    # =======================================================
    def setDatetime(self, dt):

        cmdline = 'date -s "%04s/%02s/%02s %02s:%02s:%02s"' % (
                  dt['year'], dt['month'], dt['day'], dt['hour'], dt['minute'], dt['second'])
        res = self.call(cmdline,  shell=True)
        if res:
            self.log(LOG_ERR, "DateTime: cmd '%s' failed." % cmdline)

    # =======================================================
    #
    # =======================================================
    def getTimezone(self):

        area = ["Africa", "America", "Antarctica", "Arctic", "Asia",
                "Atlantic", "Australia", "Europe", "Indian", "Pacific"]
        timsezones = []
        for a in area:
            zone = os.listdir("/usr/share/zoneinfo/" + a)
            for z in zone:
                timsezones.append({"zone": "{0}/{1}".format(a, z), "city": z})
        timsezones.append({"zone": "UTC", "city": "UTC"})

        with open("/etc/timezone", "r") as file:
            timezone = file.read().strip("\n")

        return {"timezone": timezone, "timezones": timsezones}

    # =======================================================
    #
    # =======================================================
    def setTimezone(self, dt):

        cmdline = 'date -s "%04s/%02s/%02s %02s:%02s:%02s"' % (
                  dt['year'], dt['month'], dt['day'], dt['hour'], dt['minute'], dt['second'])
        res = self.call(cmdline,  shell=True)
        if res:
            self.log(LOG_ERR, "DateTime: cmd '%s' failed." % cmdline)
