# -*- coding: utf-8 -*-
import os
import glob
import zipfile
from pppcounter import PPPCounter
from Handlers import BaseHandler

# -------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------


class Download(BaseHandler.BaseHandler):
    # =======================================================
    #
    # =======================================================
    def __init__(self):

        self.name = 'Download'
        self._config = '/rw.tmpfs/.overlay/overlays_etc.tar.xz'
        self._log = ['/rw.tmpfs/.overlay/overlays_log.tar.xz',
                     '/rw.tmpfs/.overlay/overlays_cmp_log.tar.xz']
        self._shutdown_state = '/rw.tmpfs/.overlay/shutdown_state_*'
        self._techsupport = '/tmp/techsupport'
    # =======================================================
    #
    # =======================================================
    def Get(self, request):

        status = 400
        dl = ''
        type = request.query.type
        if type == 'config':
            dl, status = self._readConfig()
        elif type == 'support':
            dl, status = self._readThchsupport()
        return dl, status

    # =======================================================
    #
    # =======================================================
    def _readConfig(self):

        status = 503
        dl = ''
        try:
            res = self.call('overlaycfg -s etc', shell=True)

            if not res:
                dl = open(self._config, 'br').read()
                status = 200
        except Exception as e:
            self.log('read config failed. %s' % e)

        self.call('mount_overlay -u', shell=True)
        return dl, status

    # =======================================================
    #
    # =======================================================
    def _readThchsupport(self):

        status = 503
        dl = ''

        self.call('overlaycfg -s log', shell=True)

        try:
            self._pppcounter_output()
            with zipfile.ZipFile(self._techsupport, 'w', zipfile.ZIP_STORED) as zf:
                for path in glob.glob(self._shutdown_state):
                    zf.write(path, path.split('/')[-1])
                for path in self._log:
                    if os.path.exists(path):
                        zf.write(path, path.split('/')[-1])
                for file in ['pppcounter.log', 'pppcounter_prev.log']:
                    path = '/tmp/' + file
                    if os.path.exists(path):
                        zf.write(path, file)

            dl = open(self._techsupport, 'br').read()
            status = 200

        except Exception as e:
            self.log('techsupport edit failed. %s' % e)

        self.call('mount_overlay -u', shell=True)
        return dl, status

    # =======================================================
    #
    # =======================================================
    def _pppcounter_output(self):

        dbpath = '/var/lib/pppcounter/pppcounter.db'
        if os.path.exists(dbpath):
            counter = PPPCounter(dbpath)
            t = counter.get_table()
            with open('/tmp/pppcounter.log', 'w') as f:
                f.write(t)
            t = counter.get_table(prev=True)
            with open('/tmp/pppcounter_prev.log', 'w') as f:
                f.write(t)
