# -*- coding: utf-8 -*-
from Handlers import BaseHandler
import os
# -------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------


class TMIS(BaseHandler.BaseHandler):
    # =======================================================
    #
    # =======================================================
    def __init__(self):
        self.agent_key = '/etc/opt/atom/agent_key'
        self.name = 'TMIS'
        self.service_name = 'atom-activation'

    # =======================================================
    #
    # =======================================================
    def Get(self, request):

        status = 200

        return self.isActive(), status

    # =======================================================
    #
    # =======================================================
    def Put(self, request):

        status = 200

        self.restart(request.json)

        return status

    # =======================================================
    #
    # =======================================================
    def isActive(self):

        result = {}
        if self.service_status("atom") == "active":
            result["status"] = "yes"
        else:
            result["status"] = "no"

        return result

    # =======================================================
    #
    # =======================================================
    def writeAgentkey(self, args):

        if "agentkey" in args["tmis"] and args["tmis"]["agentkey"]:
            with open(self.agent_key, "w") as file:
                file.write(args["tmis"]["agentkey"])

    # =======================================================
    #
    # =======================================================
    def restart(self, args):

        self.service("atom", "stop")
        self.service('atom-activation', "stop")
        if args["tmis"]["status"] == "yes":
            self.writeAgentkey(args)
            self.service('atom-activation', "enable")
        else:
            self.service('atom-activation', "disable")
            if os.path.exists(self.agent_key):
                os.remove(self.agent_key)
