# -*- coding: utf-8 -*-
from Handlers import BaseHandler
from mako.template import Template


template_ddns = Template(
r"""\
START_PPP=${start_ppp}
START_ETH=${start_eth}
SERVICE=${service}
ACCOUNT=${account}
PASSWORD=${password}

# example
#
# START_PPP=0|1
# START_ETH=0|1
# SERVICE=mydns|warplink
# ACCOUNT=username
# PASSWORD=password
""")


# -------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------

class Warplink(BaseHandler.BaseHandler):
    # =======================================================
    #
    # =======================================================
    def __init__(self):
        self.default = "/etc/default/nim_ddns"
        self.name = 'Warplink'
    # =======================================================
    #
    # =======================================================
    def Get(self, request):

        status = 200
        """
        result={}
        type = request.query.type
        if type == 'config':
            result = self.readConfig()
        elif type == 'status':
        """
        result = self.readConfig()
        return result, status

    # =======================================================
    #
    # =======================================================
    def Put(self, request):

        status = 200
        self.writeConfig(request.json)

        return status
    # =======================================================
    #
    # =======================================================
    def readConfig(self):

        conf ={}
        with open(self.default, "r") as fd:

            for line in fd:
                if line.startswith("#") == True:
                    pass
                elif line.find("=") != -1:
                    sline = line.strip("\n").split("=")
                    conf[sline[0].lower()] = sline[1]

        return conf

    # =======================================================
    #
    # =======================================================
    def writeConfig(self, args):

        conf = args["ddns"]
        config = template_ddns.render(**conf) 
        with open(self.default, "w") as fd:
            fd.write(config)

