# -*- coding: utf-8 -*-
from Handlers import BaseHandler
import json
import os
# -------------------------------------------------------------------------------
#
# -------------------------------------------------------------------------------

class Wireguard(BaseHandler.BaseHandler):
    # =======================================================
    #
    # =======================================================
    def __init__(self):
        self.default = "/etc/default/wireguard0.json"
        self.publickey = "/etc/wireguard/public.key"
        self.name = 'Wireguard'
    # =======================================================
    #
    # =======================================================
    def Get(self, request):

        status = 200
        result = self.readConfig()
        return result, status

    # =======================================================
    #
    # =======================================================
    def Put(self, request):

        status = 200
        self.writeConfig(request.json)
        self.service("wireguard@0", "restart")
        return status
    # =======================================================
    #
    # =======================================================
    def readConfig(self):

        conf ={"wg":{}, "publickey":""}
        if os.path.exists(self.default):
            with open(self.default, "r") as fd:
                wg_conf = fd.read()
                #conf = json.loads(wg_conf.replace("\n",""))
                conf["wg"] = json.loads(wg_conf)
        else:
            conf["wg"]["enable"] = False
            conf["wg"]["interface"] = {}
            conf["wg"]["peers"] =[{"keepalive":True}] 


        if os.path.exists(self.publickey):
           with open(self.publickey, "r") as fd:
               conf["publickey"] = fd.read()

        return conf

    # =======================================================
    #
    # =======================================================
    def writeConfig(self, args):

        wg = args["wg"]
        listenport = wg["interface"]["listenport"]
        port = wg["peers"][0]["port"]
        allowdips = wg["peers"][0]["allowedips"]

        if isinstance(listenport,str):
            wg["interface"]["listenport"] = int(listenport)

        if isinstance(port,str):
            wg["peers"][0]["port"] = int(port)

        if isinstance(allowdips,str):
            wg["peers"][0]["allowedips"] = allowdips.split(",")

        if isinstance(allowdips,str):
            wg["peers"][0]["allowedips"] = allowdips.split(",")

        with open(self.default, "w") as fd:
            fd.write(json.dumps(wg,indent=4))


